package outilsserveur;

import java.io.*;
import java.net.*;

// cette classe Serveur est trs gnrale et peut servir de modle
// pour tous vos futurs serveurs SANS ressources partages

public class Serveur implements Runnable {
	private ServerSocket listen_socket; // le serveur d'coute
	private Class dialClass; // la classe du dialogue
	// Cree un serveur TCP : c'est un objet de la
	// classe ServerSocket
	// Puis lance l'ecoute du serveur.
	public Serveur(String dialogueClass, int port) 
		throws IOException, ClassNotFoundException {

		    listen_socket = new ServerSocket(port);
			this.dialClass = Class.forName(dialogueClass);
			System.out.println("Serveur lance sur le port " + port);
			(new Thread(this)).start();
		
		 
	}
	protected Dialogue getUnClient() throws IOException,
						IllegalAccessException,
						InstantiationException {
				Socket client_socket = listen_socket.accept();
				Dialogue dial=(Dialogue)dialClass.newInstance();
				dial.setSocket(client_socket);
				return dial;
			}
	// Le corps de la thread d'ecoute :
	// Le serveur ecoute et accepte les connections.
	// pour chaque connection, il cree une Connection, 
	// qui va la traiter.
	public void run() {
		try {
			while(true) {
				Dialogue dial = getUnClient();
				dial.start();}
		}
		catch (IOException e) { 
			System.err.println("Pb lors de l'ecoute:"+e);
		}
		catch (InstantiationException e) { 
		 System.err.println("Pb  l'instantiation du dialogue:"+e);
		}
		catch (IllegalAccessException e) { 
		 System.err.println("Pb d'accs illgal"+e);
		}
		finally {
			try {listen_socket.close();} catch (Exception e) {}
		}
	}
}
