package serveur;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.ObjectOutputStream;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;

public class DialTchat implements Runnable{
	private Socket _mySocket;
	private int _num;
	private String _nick = null;
	private FIFO _fifo = null;
	private Chateurs _chateursautorises = new Chateurs();
	
	
	public DialTchat(Socket socket, int i) throws IOException {
		this._num = i;
		_mySocket = socket;
		
		(new Thread(this)).start();
	}

	public void run() {
		try {			
			String line,command;
		
			BufferedReader in = new BufferedReader(new InputStreamReader(_mySocket.getInputStream()));
			PrintWriter out = new PrintWriter(_mySocket.getOutputStream(), true);			

			out.println(_num);
			
			System.out.println("Nouveau DialChat pour : " + _num);
			
			while(true){
				line = in.readLine();
				
				System.out.println("Connexion " + _num + " a recu " + line);
				
				if (line == null) break;
				if (line.equals("")) break;
				
				command = Command(line);
				if(!command.equals("ok"))_fifo.push(_nick + " > " + line);
				else if(command.equals("quit"))_mySocket.close();
			}
		}
		catch (IOException e) {
			System.err.println("DialTchat / Erreur dans le dialogue des sockets : " + e);
		}

		finally { try {_mySocket.close();} catch (IOException e2) {System.err.println("DialTchat : " + e2);} }
	}
	@Override
	
	protected void finalize() throws Throwable {
		 try {_mySocket.close();} catch (IOException e2) {System.err.println("DialTchat / finalize : " + e2);} 		
	}

	
	public void setFifo(FIFO lafifo){
		_fifo = lafifo;
	}
	public void setChateursautorises(Chateurs chateursautorises){
		_chateursautorises = chateursautorises;
	}
	
	
	public String Command(String lastring){
		if(lastring.equals("/quit")){
				_fifo.push("/quit " + _num + "  " + _nick);
			return "quit";
		}
		else if(lastring.startsWith("/nick ")){
			String lnick = lastring.substring(6);
			if(_nick == null){
				_fifo.push(lnick + " vient de se connecter");
			}
			else{
				if(_chateursautorises.changenick(_nick, lnick) == 1){
					_fifo.push(_nick + " est maintenant connu en " + lnick);
				}
			}
			_nick = lnick;
			return "ok";
		}
		else if(lastring.startsWith("/pwd ")){
			if(_chateursautorises.changepwd(_nick, lastring) == 1){
				_fifo.push("Mot de passe chang pour " + _nick);
			}
			return "ok";
		}
		
		return lastring;		
	}
	
	public void Sauvegarder() throws IOException{
		FileOutputStream fout;
		try {
			fout = new FileOutputStream("chateurs.txt");
			ObjectOutputStream out = new ObjectOutputStream(fout);
			out.writeObject(_chateursautorises);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	
	}
}
