package serveur;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.PrintWriter;
import java.net.*;
import java.util.ArrayList;

public class Serveur implements Runnable{
	private int _nbcnx = 2000;
	private ServerSocket _monserveursocket;
	private FIFO _fifo = null;
	private Chateurs _chateursautorises = new Chateurs();
	private ArrayList<Socket> _listeconnectes = null;

	public Serveur(int port) throws IOException{
		_monserveursocket = new ServerSocket(port);
		(new Thread(this)).start();		
	}
	
	public void run() {
		try {
			BufferedReader sIn = null;
			PrintWriter sOut = null;
			String lnick = "";
			String lpwd = "";
			String lfname = "chateurs.txt";
			
			
//			Chargement des chateurs autorises
			try {
				ObjectInputStream in = new ObjectInputStream(new FileInputStream(lfname));
				_chateursautorises = (Chateurs) in.readObject();
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				System.out.println("Erreur : " + e);
			}
			
			
			while(true){
				Socket lasocket = _monserveursocket.accept();
				
				sIn = new BufferedReader(new InputStreamReader(lasocket.getInputStream()));
				sOut = new PrintWriter(lasocket.getOutputStream(), true);
				

				
				//En attente de connexion
				lnick = sIn.readLine();
				while(lpwd.equals("")){
					lpwd = sIn.readLine();
				}
				
				//System.out.println(lnick + lpwd);
				
				int i = _chateursautorises.Exist(lnick, lpwd);
				if(i >= 0){
					//Si un user est correctement logg
					if(i == 1){
						this.ConnectANewChateur(lasocket);
					}
					else sOut.println("Mauvais password"); 
				}
				else {
					sOut.println("Crer l'utilisateur ?");
					
					String line = sIn.readLine();
					if(line.equals("o")){
						_chateursautorises.AddChateur(lnick, lpwd);
						this.ConnectANewChateur(lasocket);
						
						FileOutputStream fout = new FileOutputStream(lfname);
						ObjectOutputStream out = new ObjectOutputStream(fout);
						out.writeObject(_chateursautorises);
					}
					else sOut.println("A bientot !");
				}
				
				lnick="";lpwd = "";
			}
		} catch (IOException e) {			
			System.err.println("Serveur / Erreur dans le dialogue des sockets : " + e);
		}
	}
	
	public void ConnectANewChateur(Socket lasocket) throws IOException{
		_nbcnx++;
		System.out.println("Nouveau client sur : " + _nbcnx);
		ServerSocket SDiffuseur = new ServerSocket(_nbcnx);
		
		DialTchat ldialtchat = new DialTchat(lasocket , _nbcnx);
		ldialtchat.setFifo(_fifo);
		ldialtchat.setChateursautorises(_chateursautorises);
		
		_listeconnectes.add(SDiffuseur.accept());
	}
		
	protected void finalize() throws IOException
	{
		_monserveursocket.close();
	}
	
	public void setFifo(FIFO lafifo){
		_fifo = lafifo;
	}
	public FIFO getFifo(){
		return _fifo;
	}
	
	public void setListeConnectes(ArrayList learraylist){
		_listeconnectes = learraylist;
	}
	public ArrayList getListeConnectes(){
		return _listeconnectes;
	}
	
	
}
